import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkWechatDeposit, ThinkWechatDepositParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkWechatDeposit(params: ThinkWechatDepositParam) {
  const res = await request.get<ApiResult<PageResult<ThinkWechatDeposit>>>(
    THINK_API_URL + '/think/think-wechat-deposit/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkWechatDeposit(params?: ThinkWechatDepositParam) {
  const res = await request.get<ApiResult<ThinkWechatDeposit[]>>(
    THINK_API_URL + '/think/think-wechat-deposit',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkWechatDeposit(data: ThinkWechatDeposit) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-wechat-deposit',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkWechatDeposit(data: ThinkWechatDeposit) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-wechat-deposit',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkWechatDeposit(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-wechat-deposit/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkWechatDeposit(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-wechat-deposit/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkWechatDeposit(id: number) {
  const res = await request.get<ApiResult<ThinkWechatDeposit>>(
    THINK_API_URL + '/think/think-wechat-deposit/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
